<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="培养员工编号" prop="staffId">
        <el-input
          v-model="queryParams.staffId"
          placeholder="请输入培养员工编号"
          clearable
          size="small"
          @input="handleQuery"
        />
      </el-form-item>
      <el-form-item label="备注" prop="remarks">
        <el-input
          v-model="queryParams.remarks"
          placeholder="请输入备注"
          clearable
          size="small"
          @input="handleQuery"
        />
      </el-form-item>
      <el-form-item label="导师员工编号" prop="mentorStaffId">
        <el-input
          v-model="queryParams.mentorStaffId"
          placeholder="请输入导师员工编号"
          clearable
          size="small"
          @input="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['spec:successor:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['spec:successor:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['spec:successor:remove']"
        >删除</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
          <el-button
                  type="info"
                  icon="el-icon-upload2"
                  size="mini"
                  @click="handleImport"
                  v-hasPermi="['spec:successor:edit']"
          >导入</el-button>
      </el-col> -->
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['spec:successor:export']"
        >导出</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="successorList" @selection-change="handleSelectionChange" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="员工编号" align="center" prop="staffId" :show-overflow-tooltip="true"/>
      <el-table-column label="培养员工" align="center" prop="staff.name" :show-overflow-tooltip="true"/>
      <el-table-column label="当前岗位" align="center" prop="staff.actualpost" :formatter="postFormat" />
      <el-table-column label="班值" align="center" prop="staff.team" :formatter="teamFormat" />
      <el-table-column label="目标岗位" align="center" prop="actualpost" :formatter="actualpostFormat" />
      <el-table-column label="导师" align="center" prop="mentorStaffName" :show-overflow-tooltip="true"/>
      <el-table-column label="培养状态" align="center" prop="state" :formatter="stSuccessorStatusFormat"/>
      <el-table-column label="一季度" align="center" prop="scoreList[0].quarterOne" :show-overflow-tooltip="true"/>
      <el-table-column label="二季度" align="center" prop="scoreList[0].quarterTwo" :show-overflow-tooltip="true"/>
      <el-table-column label="三季度" align="center" prop="scoreList[0].quarterThree" :show-overflow-tooltip="true"/>
      <el-table-column label="四季度" align="center" prop="scoreList[0].quarterFour" :show-overflow-tooltip="true"/>
      <el-table-column label="年度" align="center" prop="scoreList[0].year" :show-overflow-tooltip="true"/>
      <el-table-column label="部门" align="center" prop="deptName" :show-overflow-tooltip="true"/>
      <el-table-column label="备注" align="center" prop="remarks" :show-overflow-tooltip="true"/>
      <el-table-column label="操作" align="center" fixed="right" width="200" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            @click="planList(scope.row)"
          >培养计划</el-button>
          <el-button
            size="mini"
            type="text"
            @click="monthData(scope.row)"
          >月度历史</el-button>
          <el-button
            size="mini"
            type="text"
            @click="seasonData(scope.row)"
          >季度历史</el-button>
          <el-button
            size="mini"
            type="text"
            @click="openStaffResume(scope.row)"
          >一人一档</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['spec:successor:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['spec:successor:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改继任者清单对话框 -->
    <el-dialog  :close-on-click-modal="false" :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="培养员工" prop="staffId">
            <el-select v-model="form.staffId" filterable :placeholder="$t('请选择')+$t('学员')">
              <el-option
                v-for="item in userOption"
                :key="item.staffid"
                :label="item.name +'  '+ item.deptName"
                :value="item.staffid"
                :disabled="item.disabled">
              </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注" />
        </el-form-item>
        <el-form-item label="目标岗位" prop="actualpost">
          <el-select v-model="form.actualpost" placeholder="请选择目标岗位">
            <el-option
              v-for="dict in actualpostOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="导师员工" prop="mentorStaffId">
          <el-select v-model="form.mentorStaffId" filterable :placeholder="$t('请选择')+$t('导师')">
            <el-option
              v-for="item in userMentorOption"
              :key="item.staffid"
              :label="item.name +'  '+ item.deptName"
              :value="item.staffid"
              :disabled="item.disabled">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="培养状态" prop="state">
          <el-select v-model="form.state" placeholder="请选择培养状态">
            <el-option
              v-for="dict in stSuccessorStatusOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"

            ></el-option>
          </el-select>
        </el-form-item>
          <el-form-item label="归属部门" prop="deptId">
              <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
          </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" :loading="submitLoading"  @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
      <!-- 用户导入对话框 -->
      <el-dialog  :close-on-click-modal="false" :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
          <el-upload
                  ref="upload"
                  :limit="1"
                  accept=".xlsx, .xls"
                  :headers="upload.headers"
                  :action="upload.url + '?updateSupport=' + upload.updateSupport"
                  :disabled="upload.isUploading"
                  :on-progress="handleFileUploadProgress"
                  :on-success="handleFileSuccess"
                  :auto-upload="false"
                  drag
          >
              <i class="el-icon-upload"></i>
              <div class="el-upload__text">
                  将文件拖到此处，或
                  <em>点击上传</em>
              </div>
              <div class="el-upload__tip" slot="tip">
                  <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
                  <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
              </div>
              <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
          </el-upload>
          <div slot="footer" class="dialog-footer">
              <el-button type="primary" @click="submitFileForm">确 定</el-button>
              <el-button @click="upload.open = false">取 消</el-button>
          </div>
      </el-dialog>
    <staff-resume v-if="staffResumeVisible" ref="staffResume"></staff-resume>
  </div>
</template>

<script>
import { listSuccessor, getSuccessor, delSuccessor, addSuccessor, updateSuccessor, exportSuccessor, importTemplate ,listPostStaff,listPostMentorStaff} from "@/api/training/spec/successor";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import StaffResume from "./staffResume"

export default {
  name: "Successor",
  components: { Treeselect,StaffResume },
  data() {
    return {
      // 遮罩层
      loading: true,
      submitLoading: false,
      staffResumeVisible: false,
      // 选中数组
      ids: [],
      userOption:[],
      userMentorOption: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 继任者清单表格数据
      successorList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
      // 目标岗位字典
      actualpostOptions: [],
      teamOptions: [],
      stSuccessorStatusOptions: [],
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/spec/successor/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        staffId: null,
        remarks: null,
        mentorStaffId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = document.body.clientHeight -250
      })
    this.getList();
    this.getTreeselect();
    this.getDicts("ACTUALPOST").then(response => {
      this.actualpostOptions = response.data;
    });
    this.getDicts("TEAM_DIVIDE").then(response => {
      this.teamOptions = response.data;
    });
    this.getDicts("st_successor_status").then(response => {
      this.stSuccessorStatusOptions = response.data;
    });
    listPostStaff(this.queryParams).then(response => {
      this.userOption = response.data;
    });
    listPostMentorStaff(this.queryParams).then(response => {
      this.userMentorOption = response.data;
    });
  },
  methods: {
    /** 查询继任者清单列表 */
    getList() {
      this.loading = true;
      listSuccessor(this.queryParams).then(response => {
        this.successorList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 当前岗位字典翻译
    postFormat(row, column) {
      return this.selectDictLabel(this.actualpostOptions, row.staff.actualpost);
    },
    // 目标岗位字典翻译
    actualpostFormat(row, column) {
      return this.selectDictLabel(this.actualpostOptions, row.actualpost);
    },
    // 班值字典翻译
    teamFormat(row, column) {
      return this.selectDictLabel(this.teamOptions, row.staff.team);
    },
    stSuccessorStatusFormat(row, column) {
      return this.selectDictLabel(this.stSuccessorStatusOptions, row.state);
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        staffId: null,
        remarks: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        actualpost: null,
        mentorStaffId: null,
        state: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.form.state = '0'
      this.open = true;
      this.title = "添加继任者清单";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getSuccessor(id).then(response => {
        this.form = response.data;
        this.form.state = response.data.state.toString()
        this.open = true;
        this.title = "修改继任者清单";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          this.submitLoading = true
          if (this.form.id != null) {
            updateSuccessor(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.submitLoading = false
              this.getList();
            });
          } else {
            addSuccessor(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.submitLoading = false
              this.getList();
            });
          }
        }
      });
      //
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delSuccessor(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有继任者清单数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportSuccessor(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = "用户导入";
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
          this.upload.open = false;
          this.upload.isUploading = false;
          this.$refs.upload.clearFiles();
          this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
          this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      },
      planList(row){
        const staffId = row.staffId
        this.$router.push("/training/spec/successorPlan/" + staffId);
      },
      monthData(row){
        const staffId = row.staffId
        this.$router.push("/training/spec/monthdata/" + staffId);
      },
      seasonData(row){
        const staffId = row.staffId
        this.$router.push("/training/spec/seasondata/" + staffId);
      },
      openStaffResume(row){
        this.staffResumeVisible = true
        this.$nextTick(() => {
          this.$refs.staffResume.init(row)
        })
      }
  }
};
</script>
